%syn data for testing
function syn(infile,outfile);
load(infile)

[syn_model,iuv,syn_trans_angles]=sub_genm(gen_model_mode,flen,n_features_per_frame,object_width,...
    init_trans,init_angles,MAXT,d_trans,d_angles,noise_2d,exam_mode,noise_gen_d_trans,noise_gen_d_angles);

for fi=1:MAXT,
    for j=1:n_features_per_frame,
        ix(j,fi)=iuv(1,j,fi);
        iy(j,fi)=iuv(2,j,fi);
    end
end
save(outfile,'syn_model','ix','iy','syn_trans_angles','zinit','flen');

return
%##################################################################################################
%##################################################################################################
%##################################################################################################
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                      %
%                                                      %
%              functions                               %
%                                                      %
%                                                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [syn_model,iuv,syn_trans_angles]=sub_genm(gen_model_mode,...
    flen,n_features_per_frame,object_width,...
    init_trans,init_angles,MAXT,d_trans,d_angles,noise_2d,exam_mode,noise_gen_d_trans,noise_gen_d_angles)
%camera pixel width 4.6 mm /848pixels =5.425 um
%pixle_width_meters=4.52*10^(-6);
%n_features_per_frame=100; %featrue numbers
%zinit=zinit_meters/pixel_width_meters; %in pixels , 1 meters
%MAXT=50
syn_trans_angles=zeros(6,MAXT);

%init data
temp_model=zeros(3,n_features_per_frame,MAXT); %size is 3,n_features_per_frame,MAXT
iuv=zeros(2,n_features_per_frame,MAXT); %iuv is output image sequence size is 2,n_features_per_frame,MAXT


%init the model, object center manuplation
%model=gen_model(option,N), N=number of featrues 
%options
%0:model=a line
%1:model=gen_wiremodel(N)
%2:model=gen_cube(N);
%3:model=gen_bigwiremodel(N);
%4:model=gen_random(N);
%5:model=%a line with a sharp point in the middle
%6:model=[1000;0;0];    %X 
%7:model=[500;1000;0];    %Y
%8:model=[500;0;1000];    %Z
%9:model=gen_halfblock(N);
%10:model=gen_sphere(N);
%11:model=gen_halfsphere(N);

%use the following 2 lines if just randon features are needed.
%original_model=zeros(3,n_features_per_frame); %size is 3,n_features_per_frame,MAXT

% old_gen_method=0;
% if old_gen_method==1
%    original_model=object_width *(rand(3,n_features_per_frame));
% else
%use this if you need seb_gen_model, you can get sphere, etcs
original_model=object_width*sub_gen_model(gen_model_mode,n_features_per_frame);
%end

cg=mean(original_model(:,:,1),2);
original_model=original_model - repmat(cg,1,n_features_per_frame); %shift to center
%rotate the orginal model to the first temp_model about center
%temp_model(:,:,1) = R_init*original_model+T_init;

%max(original_model,[],2)
%min(original_model,[],2)
%mean(original_model,2)



temp_model(:,:,1) = rpyMAT(init_angles)*original_model; %rpyMAt takes radians

% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%R(:,:,1)=rpyMat([0.1,0.1,0.1]);
%T(:,:,1)=[100 100 100]';
%----- make motion trans angles 
for t=2:MAXT
    syn_trans_angles(1:3,t)= noise_gen_d_trans*[(rand-0.5),(rand-0.5),(rand-0.5)]'...
        + d_trans + syn_trans_angles(1:3,t-1);
    
    syn_trans_angles(4:6,t)=...
     noise_gen_d_angles*[(rand-0.5),(rand-0.5),(rand-0.5)]' ...
        +(d_angles)'+ syn_trans_angles(4:6,t-1);
end

%------------ add init angles
for t=1:MAXT
    syn_trans_angles(1:3,t)=(init_trans)+syn_trans_angles(1:3,t);
end

%----- motion w.r.t. object center 
for t=2:MAXT
    dT=repmat(syn_trans_angles(1:3,t)-syn_trans_angles(1:3,t-1),1,n_features_per_frame);
    dR=rpyMat([syn_trans_angles(4:6,t)-syn_trans_angles(4:6,t-1)]);
    %    temp_model(:,:,t) = dR * temp_model(:,:,t-1) + dT;
    temp_model(:,:,t) = dR * temp_model(:,:,t-1) +dT;
end

%---- shift all points to init_trans position -------------------------------
syn_model= repmat(init_trans,[1,n_features_per_frame,MAXT]) + temp_model;

%---- project to frames ----------------------------------------
for t=1:MAXT
    iuv(1,:,t)=flen*(syn_model(1,:,t)./syn_model(3,:,t));
    iuv(2,:,t)=flen*(syn_model(2,:,t)./syn_model(3,:,t));
end

% ------- add noise to image ------------
iuv=iuv + noise_2d*randn(2,n_features_per_frame,MAXT);

%-- display -----------------
figure(1)
clf
figure(2)
clf
for t=1:MAXT
    figure(1)
    %---------------- plot 3d -------------------
    plot3(syn_model(1,:,t),syn_model(2,:,t),syn_model(3,:,t),'k.');
    hold on
    plot3(0,0,0,'r.');
    uv_scale=320;
    z_scale=1000;
    plot3(uv_scale*[1 -1],uv_scale*[1 -1],[0 z_scale],'k.');
    xlabel('x-axis in pixles');
    ylabel('y-axis in pixles');
    zlabel('z-axis in pixles');
    rotate3d on;
    %---------------- plot 2d -------------------
    %    plot(uv_scale*[1 -1],uv_scale*[1 -1],[0 z_scale],'k.')
    figure(2)
    %    clf
    plot(uv_scale*[1 -1],uv_scale*[1 -1],'k.');
    hold on;
    plot(iuv(1,:,t), iuv(2,:,t),'k.');
    xlabel('u-axis in pixles');
    ylabel('v-axis in pixles');
    title(sprintf('focal length flen in pixles is %3.2f',flen));
    if    exam_mode==1
        pause
    end
    
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%
%                  functions 
%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%-----------------------gen models--------------------------------------------------
%gen_model(option,N), N=number of featrues, all 
%options
%0:model=a line
%1:model=gen_wiremodel(N)
%2:model=gen_cube(N);
%3:model=gen_bigwiremodel(N);
%4:model=gen_random(N);
%5:model=%a line with a sharp point in the middle
%6:model=[1000;0;0];    %X 
%7:model=[500;1000;0];    %Y
%8:model=[500;0;1000];    %Z
%9:model=gen_halfblock(N);
%10:model=gen_sphere(N);
%11:model=gen_halfsphere(N);

%%%%%%%%%% sub_unifrnf, unigfrom random geneartor for matlab5 or above%%%%%
%u=sub_unifrnd(0,2*pi,[1,N]);
%similar to u=sub_unifrnd(0,2*pi,[1,N]); in matlab 6.
%rout is a row of (last-first) elements
%for matlab6 replace it with 

%function rout=sub_unifrnd(min_r,max_r,size_r)
%rout=unifrnd(min_r,max_r,size_r);
%return

function rout=sub_unifrnd(min_r,max_r,size_r)
first=size_r(1);
last=size_r(2);
zeros(1,(last-first)); %set the right size
for i=first:last,
    r_i=rand* (max_r-min_r)+min_r; %set the right range
    rout(i)=r_i;
end
return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function model = sub_gen_model(option,N) %return homogeneous model
switch (option)
    case 0
        model=[   0  100  100   0;   %a line on x-axis, best to rotate on y-axis
            0   0   100  100;
            0   0    100   0;];
    case 1
        model=gen_wiremodel(N);
    case 2
        model=gen_cube(N);
    case 3
        model=gen_bigwiremodel(N);
    case 4    
        model=gen_random(N);
    case 5    
        model=[   0 100  100  0;
            0   0  100  100;
            0   0    0  0;];   %a line with a sharp point in the middle
    case 6
        model=[1000;0;0];    %X 
    case 7
        model=[500;1000;0];    %Y
    case 8
        model=[500;0;1000];    %Z
    case 9
        model=gen_halfblock(N);
    case 10
        model=gen_sphere(N);
    case 11
        model=gen_halfsphere(N);
    otherwise
        error('general_model(): invalid input argument option');
end







function model = gen_sphere(N)
%gen a randon sphere of radius = 1
%0<u<2pi, -pi/2<v<pi/2
%x=a cos v cos u, y = a cos v sin u, z = a sin v
%N=100;
u=sub_unifrnd(0,2*pi,[1,N]);
v=sub_unifrnd(-pi/2,pi/2,[1,N]);
model(1,:)=cos(v).*cos(u);
model(2,:)=cos(v).*sin(u);
model(3,:)=sin(v);
return

function model = gen_halfsphere(N)
%gen a randon sphere of radius = 1
%0<u<pi  instead of <2*pi
%N=100;
u=sub_unifrnd(0,pi,[1,N]);
v=sub_unifrnd(-pi/2,pi/2,[1,N]);
model(1,:)=cos(v).*cos(u);
model(2,:)=cos(v).*sin(u);
model(3,:)=sin(v);
return

function model = gen_random(N)
%N=200;
model = 1*(rand(3,N));
cg=mean(model,2);
model = model - repmat(cg,1,N);
%model(3,:)=0.3*model(3,:);  %squeeze the z extension to make the object more planar
%model(3,:)=zeros(1,N); flat surface 
return

function model = gen_halfblock(N)
%N=50;
model = 2*rand(3,N);
cg=mean(model,2);
model = model - repmat(cg,1,N);
%model(3,:)=0.3*model(3,:);  %squeeze the z extension to make the object more planar
model(3,:)=-1*rand(1,N);
return

function model=gen_wiremodel(NS) %???????//scale
%NS=19;
model = zeros(3,NS*NS);
X=linspace(-190,190,NS);
Y=linspace(-190,190,NS);
[X,Y]=meshgrid(X,Y);
Z = zeros(NS,NS);       
Z(5:10,5:10) = 100;
X = reshape(X, 1, NS*NS);
Y = reshape(Y, 1, NS*NS);
Z = reshape(Z, 1, NS*NS);
model = [X;Y;Z;];
return

