% ---- matlab demo: camera position change ver.2021.3.2-------------------
%Init position of the camera
%A camera is normally at eye(3)(Identity matrix of 3x3), no rotate  in world coord.sys,
%rotated vs 3 axes: an_x,an_y,an_z (an_z first, an_y second, an_x third here),to a new (camera) coord sys.
%Rc will bring a vector in world coord. to camera coord. Such that
%so Pc=Rc*Pw, Pw is a vector in world, Pc is the same vector in cam. sys.
syms an_x an_y an_z
Rc_z=[cos(an_z)   sin(an_z)   0
        -sin(an_z)   cos(an_z)   0
         0           0           1]
Rc_y=[cos(an_y)   0           -sin(an_y)
                0           1           0
         sin(an_y)    0           cos(an_y)]
Rc_x=[1                   0            0
        0                   cos(an_x)   sin(an_x)
        0                   -sin(an_x)  cos(an_x)]
Rc = Rc_x*Rc_y*Rc_z % For Rcam, the camera moves around x-axis first, then  y-axis, finally z-axis 
Rc_cam=transpose(Rc)

% (assume extrinsic rotation), therefore Rcam = *Rcam_z*Rcam_y*Rcam_x,  since Rc=inverse(Rcam) , 
% so Rc= Rc_x*Rc_y*Rc_z 
%Properties transpose(R)*R=I, inverse(R)*R=I, inverse(R)=transpose(R), det(R)=I .