function ba_notes1
%test bundle adjustment for notes 28.3.2014 khwong
%method='synn';
method='real';
if method =='synn'
    % clear
    % close all
    n_features_per_frame=100;
    %n_features_per_frame=5;
    
    MAXT=15;
    %MAXT=7;
    
    flen=848;
    exam_mode=0;
    gen_model_mode=4; % 4=radom or 10=sphere
    pixel_width_meters=5.42*10^-6; %in meters
    init_angles=[45 45 0]*(pi/180); %in radian
    zinit=0.5/pixel_width_meters; %in pixel(center of object=0.5 m from cam center)
    init_trans=[0 0 zinit]' ;%in pixels
    
    
    %#######################################################################
    %%%%%%%%%%%% change the following for a new test =====================
    %noise_2d=1; %in pixels
    noise_2d=0; %in pixels, no noise
    
    object_width=0.13/pixel_width_meters; %in pixel
    
    %d_trans=10^-3*[0.5 0.4 0.3]'/pixel_width_meters; %in pixels, delta change for each move (1mm, 0.5 mm, 0.3 mm)
    d_trans=10^-3*[0.1 0.08 0.09]'/pixel_width_meters; %in pixels, delta change for each move (1mm, 0.5 mm, 0.3 mm)
    
    %noise_gen_d_trans=10^-3*1/pixel_width_meters; %1mm, in pixels, max. random trans added using noise_gen_d_trans*(rand-0.5)*[1 1 1]'
    noise_gen_d_trans=0/pixel_width_meters; %in pixels, max. random trans added using noise_gen_d_trans*(rand-0.5)*[1 1 1]'
    
    %   d_angles_degrees=[0.5 -0.8 1 ]; %in radian, delta rotations in degress
    
    d_angles=[0.3 -0.1 0.1]*(pi/180); %ok1, in radian, delta rotations in each step
    %d_angles=[0.12 -0.2 0.1]*(pi/180); %ok2, in radian, delta rotations in each step
    %d_angles=[0 0 0.3]*(pi/180); %ok1, in radian, delta rotations in each step
    %d_angles=[0.5 -0.2 0.3]*(pi/180); %ok2, in radian, delta rotations in each step
    %d_angles=[1 -0.08 0.3]*(pi/180); %, in radian, delta rotations in each step
    
    noise_gen_d_angles=3*(pi/180) %1 degree in radian, max. random angle added using noise_gen_d_angles*(rand-0.5)*[1 1 1 ]'
    %noise_gen_d_angles=0*(pi/180) %in radian, max. random angle added using noise_gen_d_angles*(rand-0.5)*[1 1 1 ]'
    %#################  generate random data ################################
    save('syn_in');
    %[syn_model,ix,iy,syn_trans_angles,zinit,flen]=syn1('syn_in','syn_dat'); %will get syn_in as inpuy
    %syn1(infiile, outfile);
    
    % comment the folloing oine if you use one set of data for various tests
    syn1('syn_in','syn_dat'); %will get syn_in as, update the testign dtaa ***
    
    load syn_dat
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if method =='real'
    load klt_data_box5;
end

%% setup parameters %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
iter=100 % max iteration allowed, this controlls the accuarcy of the modle output
display_tag=0% 1=with pause for every itertion;0=no pause,direct gen result
lowe202_outfile='lowe202_out';%name the output-file
%--------------------------------------------------------

[N,T]=size(ix);

%% init the system %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%creat the model, in matlab it make the code more efficient,
%can be removed if you want, in C++ you can create the matrix/array first
if ~exist('model')  %if model not exists in lowe202_infile,  init model
    model = zeros(3,N);   %model = 3*N
    model = [ix(:,1)'; iy(:,1)'; zeros(1,N)]; %back project the first image
    model = (zinit/flen) .* model;
end
model = [model; ones(1,N)];     %turn into homogeneous coordinate

if ~exist('rt')
    rt=zeros(3,4,T);
    rt(:,:,1)=[eye(3) [0;0;zinit]];
end
if size(rt,3)~=T
    disp('lowe202: size of rt not matched with ix,iy');
end


%----------------- processing -----------------------------------
t0=cputime;   %reset counter
et=[]; er=[];
dT=zeros(3,1);   %bug fix khw130416
%check_terminate_tag=0;  %1 the number of iterations may be smaller; 0 n-->iter
for n = 1:iter
    
    pause(0)
    %%% SECTION TITLE
    % DESCRIPTIVE TEXT
    'lowe202'
    n
    
    for j=1:T
        if rt(3,4,j)==0
            rt(:,:,j)=rt(:,:,j-1);
        end
        v = find(~isnan(ix(:,j)));         %find valid points
        err=column_err(flen, model(:,v), ix(v,j), iy(v,j), rt(:,:,j),0);
        
        J = JacobRT(flen, model(:,v), rt(:,:,j),dT);
        
        delta = J\err;		%delta=3T+3T
        dT = delta(1:3);
        dR = delta(4:6);
        rt(1:3,4,j) = rt(1:3,4,j)+dT;
        %alternative method
        an1=dR(1);
        an2=dR(2);
        an3=dR(3);
        dR_mat=[ 1   -an3 an2
                an3   1   -an1
                -an2 an1   1];
      
        %rt(1:3,1:3,j) = rpymat(dR)*rt(1:3,1:3,j); %original implemenation
        rt(1:3,1:3,j) = dR_mat*rt(1:3,1:3,j); %new 210302
        
        %added by khw
        %        constraint = rpyAng(rt(1:3,1:3,1));   %get angle of 1st image
        %        rt(1:3,1:3,j)=rpymat(  rpyAng(rt(1:3,1:3,j))-constraint);
        %adding ends
    end
    
    err=project_err(flen, model, ix, iy, rt,0);
    err2=mserror(err);
    
    for i=1:N
        if model(4,i)~=0
            v = find(~isnan(ix(i,:)));
            err=row_err(flen,model(:,i),ix(i,v),iy(i,v),rt(:,:,v));
            J = JacobM(flen, model(:,i), rt(:,:,v));
            delta = J\err;
            model(1:3,i) = model(1:3,i) + delta;
        end
    end
    
    err=project_err(flen, model, ix, iy, rt,0);
    er(n)=mserror(err)  %2d error
    %     if n==1
    %         et(n)=0;
    %     else
    %         et(n)=cputime-t0;
    %     end
    et(n)=cputime-t0;
    
    if abs(err)+abs(err2) < 0.1  %if improvement is less than 0.1%
        %this controlls the accuarcy of the modle output
        
        break
    end
end %end iteration

%%%%%%%%%%%%%%%%%%%%%%%  31 %%%%%%%%%%%%%%%%%%%%%%%
figure(31)
clf
%%%%%%%%%%%%%%%%%%% plot output model --------------
xx=normalize2(model(1:3,:));
%plot3(xx(1,:),xx(2,:),xx(3,:),'.');
%mesh(xx(1,:)',xx(2,:)',xx(3,:)');

ti = -0.2:.01:0.2; 
[XI,YI] = meshgrid(ti,ti);
ZI = griddata(xx(1,:),xx(2,:),xx(3,:),XI,YI);
%Plot the gridded data along with the nonuniform data points used to generate it:

mesh(XI,YI,ZI), hold
%plot3(xx(1,:),xx(2,:),xx(3,:),'o'), hold off


%surf(xx)
hold on
title('model points in 3D')
xlabel('X')
ylabel('Y')
zlabel('Z')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%32 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if method=='synn'
    %%%%%%%%%%%%%%%%%%%%%%%%%%% plot syn model --------
    xxs=syn_model(:,:,1);
    xxs=normalize2(xxs)
    plot3(xxs(1,:),xxs(2,:),xxs(3,:),'o');
    
    figure(32)
    clf
    hold on
    for i=1:length(xx)
        plot3(xx(1,i),xx(2,i),xx(3,i),'.');
        num_txt=sprintf('  >%d',i);
        text(xx(1,i),xx(2,i),xx(3,i),num_txt)
        
        %%%% plaot syn model
        plot3(xxs(1,i),xxs(2,i),1*xxs(3,i),'o');
        num_txt=sprintf('   -S%d',i);
        text(xxs(1,i),xxs(2,i),1*xxs(3,i),num_txt,'color','r')
        
        xlabel('X')
        ylabel('Y')
        zlabel('Z')
        
    end
    norm(xx(1,:))
    norm(xx(2,:))
    norm(xx(3,:))
    
    norm(xxs(1,:))
    norm(xxs(2,:))
    norm(xxs(3,:))
end


% dd=abs(xx-xxs);
% dd
% norm(dd)
%
% sum(dd,2)
% mean(dd,2)


%%%%%%%%%%%% end of program %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%% functions %%%%%%%%%%%%%%%%%%
%for display result for the final result
project_err(flen, model, ix, iy, rt, display_tag);

%generate all views of  model
[N,T]=size(ix);
m=cell(T,2);
for t=1:T
    v=find(~isnan(ix(:,t)));
    X=rt(:,:,t)*model(:,v);   %rt=3*4*frames
    m{t,1}=t;
    m{t,2}=X;
end

model=model(1:3,:);     %eliminate the 4th row of ones


% if syn_tag==1
%     save(lowe202_outfile,'m','ix','iy','flen','model','rt','er','et','syn_tag','syn_trans_angles','zinit','syn_tag');
% else
save(lowe202_outfile,'m','ix','iy','flen','model','rt','er','et','zinit');
% end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% figure(231)
% clf
% plot(et,er,'r+-')
% plot_title('lowe202, 2d er plot vs cpu_time');
% %et
%
% figure(30)
% hold on
% plot(et,er,'r+-')
% %plot_title('lowe202, 2d er plot vs cpu_time');
% %et



return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%              fucntions                                 %%%%%%%%%%
%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function e = mserror(v)  %calc the mean square error
e = sqrt(sum(v.^2)/(length(v)/2));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function err=column_err(flen,model,ix,iy,rt,display_tag,t)
%return err, a column vector of max size 3*N*T
[N,T]=size(ix);
if T~=1
    error('column_err: ix, iy must be a column vector');
end
X = rt*model;
x = flen.*X(1,:)./X(3,:);
y = flen.*X(2,:)./X(3,:);
ex = ix - x';
ey = iy - y';
err = [ex; ey]; %ix is 300x1 ,

if display_tag==1
    t
    figure(202)
    clf
    hold on
    plot(ix,iy,'bx');
    plot(x',y','ro');
    plot_title('in lowe202 col_err,2d error: syn_dat=bx,found=ro, press for next frame' );
    pause
end

return



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function err=row_err(flen,model,ix,iy,rt)
%return err, a column vector of max size 3*N*T
[N,T]=size(ix);
if N~=1
    error('row_err: ix, iy must be a row vector');
end
err=zeros(2*T,1);
for t=1:T
    X = rt(:,:,t)*model;
    x = flen.*X(1,:)./X(3,:);
    y = flen.*X(2,:)./X(3,:);
    err(t) = (ix(1,t) - x)';
    err(T+t) = (iy(1,t) - y)';
end
return
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function err=project_err(flen,model,ix,iy,rt,display_tag)
%return err, a column vector of max size 3*N*T
[N,T]=size(ix);
err=[];

hold on
for t=1:T
    v = find(~isnan(ix(:,t)));         %find valid points that is not the start point
    s = find(model(4,:)==0);        %find uninitialised points
    v = setdiff(v,s);               %eliminate uninit points
    err = [err; column_err(flen,model(:,v),ix(v,t),iy(v,t),rt(:,:,t),display_tag,t)];
end


return

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function J=JacobM(flen, model, rt)
N = size(model,2);    %model=3,N
if N~=1
    error('JacobM: model size must be 4*1');
end
T = size(rt,3);       %rt=3,4,T
J=zeros(2*T,3);

for t=1:T             %index T vertical blocks
    V = rt(:,:,t)*model;
    X = V(1,:);
    Y = V(2,:);
    Z = V(3,:);
    Z2 = Z.*Z;
    XZ2 = X./Z2;
    YZ2 = Y./Z2;
    a11 = rt(1,1,t)./Z - rt(3,1,t).*XZ2;
    a12 = rt(1,2,t)./Z - rt(3,2,t).*XZ2;
    a13 = rt(1,3,t)./Z - rt(3,3,t).*XZ2;
    a21 = rt(2,1,t)./Z - rt(3,1,t).*YZ2;
    a22 = rt(2,2,t)./Z - rt(3,2,t).*YZ2;
    a23 = rt(2,3,t)./Z - rt(3,3,t).*YZ2;
    a1 = [a11' a12' a13'];
    a2 = [a21' a22' a23'];
    
    J(t,:) = a1;
    J(T+t,:) = a2;
end
J = flen.*J;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%extended lowe
function J=JacobRT(flen, model, rt,dT)
%find RT with the R in frame 1 included
T = size(rt,3);       %rt=3,4,T
if (T~=1)
    error('rt size must be 3*4*1 only (T must equal to 1');
end
N = size(model,2);
J=zeros(2*N,6);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%130416this is to fix the bug in the xlowe implementation--begin
%experimental result shos that fix 2 is beeter than 1, ?? cannot explain
%in fact two are same, but different implentatiuons, both do not have approx.
bug_fix_tag=1;% 0= no fix, 1 = method 1(new), 2= method 2(bad fix, based on old method)
%now bug 1 and 2 are the same., key fix: rotated_model = rt(1:3,1:3)*model(1:3,:); %XR=RM
if bug_fix_tag==1
    XXR = rt*model;		%X=RM+T
    
    %rotated_model = rt(1:3,1:3)*model(1:3,:); %XR=RM, may be  abug
    rotated_model = rt(1:3,1:3)*model(1:3,:)+repmat(dT,1,N);% impoved slightly XR=RM,+dt (fix by khw 130416)
    
    J=zeros(2*N,6);%setup the matrix
    for j=1:N
        XR=XXR(1,j);
        YR=XXR(2,j);
        ZR=XXR(3,j);
        ZR2=XXR(3,j).*XXR(3,j);
        
        X=rotated_model(1,j);
        Y=rotated_model(2,j);
        Z=rotated_model(3,j);
        J(2*(j-1)+1,:)=flen*[1/ZR 0    -XR/ZR2   -(Y*XR)/ZR2     (X*XR+Z*ZR)/ZR2  -Y/ZR];
        J(2*(j-1)+2,:)=flen*[0    1/ZR -YR/ZR2  -(Y*YR+Z*ZR)/ZR2 (XR*X)/ZR2      X/ZR];
        
        %J(2*(j-1)+1,:)=flen*[1/ZR 0    -XR/ZR2   -(Y*XR)/ZR2     (X*XR+Z*ZR)/ZR2  -Y/ZR];
        %J(2*(j-1)+2,:)=flen*[0    1/ZR -YR/ZR2  -(Y*YR+Z*ZR)/ZR2 (XR*X)/ZR2      X/ZR];
        
    end
    %  J_fix=J
    %fix the jacobian
    J2=J;
    for j=1:N
        J(j,:)=J2(2*(j-1)+1,:);
        J(j+N,:)=J2(2*(j-1)+2,:);
    end
    
end


% J2=J;
%  J2
%  bug_fix_tag=2

if bug_fix_tag==2 %based on old program rearrange jacobin
    %this fix fails
    %this is to fix the bug in the xlowe implementation--ends
    %else
    % the old version may have bug in jacob cal.
    %1:3T columns for translation
    X = rt*model;		%X=RM+T
    XR = rt(1:3,1:3)*model(1:3,:); %XR=RM
    Z2 = X(3,:).*X(3,:);
    
    %translation part
    x1 = 1./X(3,:);
    x2 = zeros(1,N);
    x3 = -X(1,:)./Z2;
    y1 = x2;
    y2 = x1;
    y3 = -X(2,:)./Z2;
    J(:,1:3) = [x1' x2' x3'; y1' y2' y3'];
    
    %new fixes ared heer for reference
    %J(2*(j-1)+1,:)=flen*[1/ZR 0    -XR/ZR2   -(Y*XR)/ZR2     (X*XR+Z*ZR)/ZR2  -Y/ZR];
    %J(2*(j-1)+2,:)=flen*[0    1/ZR -YR/ZR2  -(Y*YR+Z*ZR)/ZR2 (XR*X)/ZR2      X/ZR];
    %rotation part
    %x1 = -X(1,:).*XR(2,:)./Z2;       %dxdalpha, tested ok, but not sure
    %x1 = -X(2,:).*XR(1,:)./Z2;       %dxdalpha, fix khwong 040412?? %same
    x1 = -X(1,:).*XR(2,:)./Z2;       %dxdalpha, fix khwong 130416 fix,
    %the above , this do not have much effefct
    %
    %     x1
    %     new_x1 = -X(1,:).*XR(2,:)./Z2
    %    new_x1-x1
    %     pause
    
    x2 = (X(1,:).*XR(1,:)+X(3,:).*XR(3,:))./Z2;
    
    x3 = -XR(2,:)./X(3,:);
    y1 = -(X(2,:).*XR(2,:)+X(3,:).*XR(3,:))./Z2;
    
    y2 = (XR(1,:).*X(2,:))./Z2; %proved to be correct by theory & experi.
    %bad fix : y2 = (XR(1,:).*X(1,:))./Z2;%(XR*X)/ZR2 ? test , bad fix
    
    y3 = XR(1,:)./X(3,:);
    J(:,4:6) = [x1' x2' x3'; y1' y2' y3'];
    
    J = flen.*J;
end
%  J
%  J2-J
%  'hi testj-j'
%  pause
% 'fixed 2 J: old method modified'
% J
% pause
% Author: Rodrigo Carceroni
% Disclaimer: This code comes with no guarantee at all and its author
%   is not liable for any damage that its utilization may cause.
%%%%%%%%%%%%%%%%% bug fix ********************************
if bug_fix_tag==0 %no fix, butthis code may have bug
    % the old version may have bug in entries of the jacob.
    %1:3T columns for translation
    X = rt*model;		%X=RM+T
    XR = rt(1:3,1:3)*model(1:3,:); %XR=RM
    Z2 = X(3,:).*X(3,:);
    
    %translation part
    x1 = 1./X(3,:);
    x2 = zeros(1,N);
    x3 = -X(1,:)./Z2;
    y1 = x2;
    y2 = x1;
    y3 = -X(2,:)./Z2;
    J(:,1:3) = [x1' x2' x3'; y1' y2' y3'];
    
    %rotation part
    x1 = -X(1,:).*XR(2,:)./Z2;       %dxdalpha
    x2 = (X(1,:).*XR(1,:)+X(3,:).*XR(3,:))./Z2;
    x3 = -XR(2,:)./X(3,:);
    y1 = -(X(2,:).*XR(2,:)+X(3,:).*XR(3,:))./Z2;
    y2 = (XR(1,:).*X(2,:))./Z2;
    y3 = XR(1,:)./X(3,:);
    J(:,4:6) = [x1' x2' x3'; y1' y2' y3'];
    
    J = flen.*J;
    %     J
    %     pause
end
